﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace LoLHelper.AdminPages
{
    enum StateOfPage {Create, Update };
    /// <summary>
    /// Логика взаимодействия для AddHeroPage.xaml
    /// </summary>
    public partial class AddHeroPage : Page
    {
        string path;
        StateOfPage stateOfPage;
        Heroes hero = new Heroes();
        void addItems()
        {
 CBType.ItemsSource = DataBase.entity.HeroTypes.ToList();
            CBType.SelectedValuePath = "ID";
            CBType.DisplayMemberPath = "Type";
            LBItems.ItemsSource = DataBase.entity.Items.ToList();
            LBItems.SelectedValuePath = "ID";
            LBItems.DisplayMemberPath = "Name";
            LBRoles.ItemsSource = DataBase.entity.Roles.ToList();
            LBRoles.SelectedValuePath = "ID";
            LBRoles.DisplayMemberPath = "Role";
            LBTests.ItemsSource = DataBase.entity.UserProfile.ToList();
            LBTests.SelectedValuePath = "ID";
            LBTests.DisplayMemberPath = "Login";
        }
        public AddHeroPage()
        {
            InitializeComponent();
            addItems();
            stateOfPage = StateOfPage.Create;
        }

        public AddHeroPage(int id)
        {
            InitializeComponent();
            AddHero.Content = "Сохранить изменения";
            addItems();
            stateOfPage = StateOfPage.Update;
            hero = DataBase.entity.Heroes.FirstOrDefault(x => x.ID == id);
            path = hero.Photo;
            TBHeroName.Text = hero.Name;
            CBType.SelectedIndex = hero.Type - 1;
            List<HeroItems> HI = DataBase.entity.HeroItems.Where(x => x.HeroID == hero.ID).ToList();
            foreach(Items items in LBItems.Items)
            {
                if(HI.FirstOrDefault(x => x.ItemID == items.ID) != null)
                {
                    LBItems.SelectedItems.Add(items);
                }
            }
            List<FavouriteHero> FH = DataBase.entity.FavouriteHero.Where(x => x.HeroID == hero.ID).ToList();
            foreach (UserProfile items in LBTests.Items)
            {
                if (FH.FirstOrDefault(x => x.UserProfileID == items.ID) != null)
                {
                    LBTests.SelectedItems.Add(items);
                }
            }
            List<HeroRoles> HR = DataBase.entity.HeroRoles.Where(x => x.IDHero == hero.ID).ToList();
            foreach (Roles items in LBRoles.Items)
            {
                if (HR.FirstOrDefault(x => x.IDRole == items.ID) != null)
                {
                    LBRoles.SelectedItems.Add(items);
                }
            }
        }

        private void BackToList_Click(object sender, RoutedEventArgs e)
        {
            AdminPage adminPage = new AdminPage();
            adminPage.DotaHelperPanel.Visibility = Visibility.Visible;
            adminPage.StartButton.Visibility = Visibility.Collapsed;
            adminPage.DotaHelper.ItemsSource = DataBase.entity.Heroes.ToList();
            adminPage.BackButton.Visibility = Visibility.Visible;
            ClassFrame.MFrame.Navigate(adminPage);
        }

        private void BackToMenu_Click(object sender, RoutedEventArgs e)
        {
            ClassFrame.MFrame.Navigate(new AdminPage());
        }

        private void AddHero_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                bool flag = true;
                while (flag)
                {
                    
                    if (stateOfPage == StateOfPage.Create)
                    {
                        hero.Name = TBHeroName.Text;
                        hero.Type = ((HeroTypes)CBType.SelectedItem).ID;
                        hero.Photo = path;
                        DataBase.entity.Heroes.Add(hero);
                    }
                    else
                    {
hero.Name = TBHeroName.Text;
                    hero.Type = ((HeroTypes)CBType.SelectedItem).ID;
                        hero.Photo = path;
                    }
                   
                    List<HeroItems> HI = DataBase.entity.HeroItems.Where(x => x.HeroID == hero.ID).ToList();
                    if (HI.Count > 0)
                    {
                        foreach (HeroItems item in HI)
                        {
                            DataBase.entity.HeroItems.Remove(item);
                        }
                    }
                    foreach (Items item in LBItems.SelectedItems)
                    {
                        HeroItems HE = new HeroItems();
                        HE.HeroID = hero.ID;
                        HE.ItemID = item.ID;
                        DataBase.entity.HeroItems.Add(HE);
                    }
                    List<FavouriteHero> US = DataBase.entity.FavouriteHero.Where(x => x.HeroID == hero.ID).ToList();
                    if (US.Count > 0)
                    {
                        foreach (FavouriteHero item in US)
                        {
                            DataBase.entity.FavouriteHero.Remove(item);
                        }
                    }
                    foreach (UserProfile item in LBTests.SelectedItems)
                    {
                        FavouriteHero FH = new FavouriteHero();
                        FH.HeroID = hero.ID;
                        FH.UserProfileID = item.ID;
                        DataBase.entity.FavouriteHero.Add(FH);
                    }
                    List<HeroRoles> HL = DataBase.entity.HeroRoles.Where(x => x.IDHero == hero.ID).ToList();
                    if (HL.Count > 0)
                    {
                        foreach (HeroRoles item in HL)
                        {
                            DataBase.entity.HeroRoles.Remove(item);
                        }
                    }
                    foreach (Roles item in LBRoles.SelectedItems)
                    {
                        HeroRoles HR = new HeroRoles();
                        HR.IDHero = hero.ID;
                        HR.IDRole = item.ID;
                        DataBase.entity.HeroRoles.Add(HR);
                    }
                    
                    if (hero.Name.Length <= 0 || LBRoles.SelectedIndex < 0 || LBItems.SelectedIndex < 0 || hero.Type == 0 || LBTests.SelectedIndex < 0)
                    {
                        MessageBox.Show("Вы ввели не все данные!!!");
                        flag = false;
                    }
                    else
                    {
                        if (stateOfPage == StateOfPage.Create)
                    {
                        MessageBox.Show("Добавление героя успешно завершено!");
                    }
                    else
                    {
                        MessageBox.Show("Изменение данных героя успешно завершено!");


                    }
                        DataBase.entity.SaveChanges();
                    AdminPage adminPage = new AdminPage();
                    adminPage.DotaHelperPanel.Visibility = Visibility.Visible;
                    adminPage.StartButton.Visibility = Visibility.Collapsed;
                    adminPage.DotaHelper.ItemsSource = DataBase.entity.Heroes.ToList();
                    adminPage.BackButton.Visibility = Visibility.Visible;
                    ClassFrame.MFrame.Navigate(adminPage);
                        flag = false;
                    }
                }
                    
                
            }
            catch
            {
                MessageBox.Show("При добавлении данных произошла ошибка!");
            }
        }

        private void BTPhoto_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog OFD = new OpenFileDialog();
            OFD.ShowDialog();
            path = OFD.FileName;
            int n = path.IndexOf("\\Images");
            path = path.Substring(n);
        }
    }
}
