﻿using LoLHelper.AdminPages;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace LoLHelper
{
    /// <summary>
    /// Логика взаимодействия для AdminPage.xaml
    /// </summary>
    public partial class AdminPage : Page
    {
        int ID;
        public AdminPage()
        {
            InitializeComponent();
            if(DotaHelper.Items != null)
            {
                DotaHelper.Items.Clear();
            }
            DotaHelper.ItemsSource = DataBase.entity.Heroes.ToList(); 
            List<HeroTypes> heroTypes = DataBase.entity.HeroTypes.ToList();
            CBFilterType.Items.Add("Все типы");
            foreach(HeroTypes type in heroTypes)
            {
                CBFilterType.Items.Add(type.Type);
            }
            CBFilterType.SelectedIndex = 0;
        }

        void Filter()
        {
            List<Heroes> hero = new List<Heroes>();
            
            string type = CBFilterType.SelectedValue.ToString();
            int id = CBFilterType.SelectedIndex;
            if(id != 0)
            {
                hero=DataBase.entity.Heroes.Where(x => x.HeroTypes.ID==id).ToList();
            }
            else
            {
                hero = DataBase.entity.Heroes.ToList();
            }
            if (!string.IsNullOrWhiteSpace(TBSearch.Text))
            {
                hero = hero.Where(x => x.Name.ToLower().Contains(TBSearch.Text.ToLower())).ToList();
            }
            if (CBPhotoYes.IsChecked == true && CBPhotoNo.IsChecked == false)
            {
                hero = hero.Where(x => x.Photo != null).ToList();
            }
            if (CBPhotoNo.IsChecked == true && CBPhotoYes.IsChecked == false)
            {
                hero = hero.Where(x => x.Photo == null).ToList();
            }
            if (RBTypeHero.IsChecked == true)
            {
                SPType.Visibility = Visibility.Visible;
                SPName.Visibility = Visibility.Collapsed;
                if (RBUpType.IsChecked == true)
                {
                    hero.Sort((x, y) => x.Type.CompareTo(y.Type));
                }
                else if (RBDownType.IsChecked == true)
                {
                    hero.Sort((x, y) => x.Type.CompareTo(y.Type));
                    hero.Reverse();
                }

            }
            if (RBName.IsChecked == true)
            {
                SPName.Visibility = Visibility.Visible;
                SPType.Visibility = Visibility.Collapsed;
                if (RBUpName.IsChecked == true)
                {
                    hero.Sort((x, y) => x.Name.CompareTo(y.Name));
                }
                else if (RBDownName.IsChecked == true)
                {
                    hero.Sort((x, y) => x.Name.CompareTo(y.Name));
                    hero.Reverse();
                }
            }
            DotaHelper.ItemsSource = hero;
        }

        private void GetInformation(object sender, RoutedEventArgs e)
        {
            UserTable.Visibility = Visibility.Visible;
            StartButton.Visibility = Visibility.Collapsed;
            BackButton.Visibility = Visibility.Visible;
            UserInformation.ItemsSource = DataBase.entity.User.ToList();
        }

        private void DotaHelperInfo(object sender, RoutedEventArgs e)
        {
            DotaHelper.ItemsSource = DataBase.entity.Heroes.ToList();
            DotaHelperPanel.Visibility = Visibility.Visible;
            StartButton.Visibility = Visibility.Collapsed;
            BackButton.Visibility = Visibility.Visible;
        }
        private void Back(object sender, RoutedEventArgs e)
        {
            StartButton.Visibility = Visibility.Visible;
            BackButton.Visibility = Visibility.Collapsed;
            DotaHelperPanel.Visibility = Visibility.Collapsed;
            UserTable.Visibility = Visibility.Collapsed;
        }
            private void MGender(object sender, RoutedEventArgs e)
        {
            UserInformation.ItemsSource = DataBase.entity.User.Where(x => x.UserGender.Gender == "мужской").ToList();
        }

        private void WGender(object sender, RoutedEventArgs e)
        {
            UserInformation.ItemsSource = DataBase.entity.User.Where(x => x.UserGender.Gender == "женский").ToList();
        }

        private void NSearch(object sender, RoutedEventArgs e)
        {
            UserInformation.ItemsSource = DataBase.entity.User.Where(x => x.Name == NameSearch.Text).ToList();
        }

        private void LSearch(object sender, RoutedEventArgs e)
        {
            UserInformation.ItemsSource = DataBase.entity.User.Where(x => x.Login == LoginSearch.Text).ToList();
        }

        private void Up(object sender, RoutedEventArgs e)
        {
            UserInformation.ItemsSource = DataBase.entity.User.OrderBy(x=>x.Surname).ToList();
        }

        private void Down(object sender, RoutedEventArgs e)
        {
            UserInformation.ItemsSource = DataBase.entity.User.OrderByDescending(x => x.Surname).ToList();
        }

        private void TextBlock_Loaded(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            int index = Convert.ToInt32(tb.Uid);
            List<HeroItems> IT = DataBase.entity.HeroItems.Where(x => x.HeroID == index).ToList();
            string str = "";
            foreach(HeroItems item in IT)
            {
                str += item.Items.Name + ", ";
            }
            tb.Text = "Предметы героя: "+str.Substring(0, str.Length - 2);
        }

        private void TextBlock_Loaded_1(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            int index = Convert.ToInt32(tb.Uid);
            List<HeroRoles> IT = DataBase.entity.HeroRoles.Where(x => x.IDHero == index).ToList();
            string str = "";
            foreach (HeroRoles item in IT)
            {
                str += item.Roles.Role + ", ";
            }
            tb.Text = "Роли героя: "+str.Substring(0, str.Length - 2);
        }

        private void TextBlock_Loaded_2(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            int index = Convert.ToInt32(tb.Uid);
            List<FavouriteHero> IT = DataBase.entity.FavouriteHero.Where(x => x.HeroID == index).ToList();
            string str = "";
            foreach (FavouriteHero item in IT)
            {
                str += item.UserProfile.Login + ", ";
            }
            tb.Text = "Пользователи, играющие за героя: "+str.Substring(0, str.Length - 2);
        }

        private void TextBlock_Loaded_3(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            int index = Convert.ToInt32(tb.Uid);
            List<HeroItems> IT = DataBase.entity.HeroItems.Where(x => x.HeroID == index).ToList();
            int count=0;
            foreach (HeroItems item in IT)
            {
                count++;
            }
            tb.Text = "Количество недостающих в сборке вещей: "+Convert.ToString(9-count);
        }

        private void AddHero_Click(object sender, RoutedEventArgs e)
        {
            ClassFrame.MFrame.Navigate(new AddHeroPage());
        }

        private void RedactHero_Click(object sender, RoutedEventArgs e)
        {
            Button button = (Button)sender;
            int index = Convert.ToInt32(button.Uid);
            ClassFrame.MFrame.Navigate(new AddHeroPage(index));
        }

        private void Delete_Click(object sender, RoutedEventArgs e)
        {
            Button btn = (Button)sender; 
            int index = Convert.ToInt32(btn.Uid);
            Heroes DeleteHero = DataBase.entity.Heroes.FirstOrDefault(x => x.ID ==  index);
            switch (MessageBox.Show("Вы точно хотите удалить героя?", "DeleteHero", MessageBoxButton.YesNo, MessageBoxImage.Question))
            {
                case MessageBoxResult.Yes:
                    DataBase.entity.Heroes.Remove(DeleteHero);
                    MessageBox.Show("Герой успешно удалён");
                    DataBase.entity.SaveChanges();
                    AdminPage adminPage = new AdminPage();
                    adminPage.DotaHelperPanel.Visibility = Visibility.Visible;
                    adminPage.StartButton.Visibility = Visibility.Collapsed;
                    adminPage.DotaHelper.ItemsSource = DataBase.entity.Heroes.ToList();
                    adminPage.BackButton.Visibility = Visibility.Visible;
                    ClassFrame.MFrame.Navigate(adminPage);
                    break;
                case MessageBoxResult.No:
                    MessageBox.Show("Герой успешно не удалён");
                    break;
            }
        }

        private void CBType_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void TBSearch_TextChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }

        private void CBPhotoYes_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void CBPhotoNo_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void CBPhotoYes_Unchecked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void CBPhotoNo_Unchecked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBCountItem_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBName_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBUpType_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBDownType_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBNowType_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }
        private void RBUpName_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBDownName_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBNowName_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void BTNLocal_Click(object sender, RoutedEventArgs e)
        {
            SPCheck.Visibility= Visibility.Visible;
            StartButton.Visibility= Visibility.Collapsed;
        }

        private void BTNCheck_Click(object sender, RoutedEventArgs e)
        {
            int p = PBRetryPassword.Password.GetHashCode();
            User userNow = DataBase.entity.User.FirstOrDefault(x => x.Password == p);
            ID = userNow.id;
            if (userNow != null)
            {
                SPCheck.Visibility = Visibility.Collapsed;
                StartButton.Visibility = Visibility.Visible;
                MessageBox.Show("Благодарим за доверие! Теперь вы попадёте в личный кабинет");
                ClassFrame.MFrame.Navigate(new UserPage(ID));
            }
            else
            {
                MessageBox.Show("Пароль введён неверно!");
            }
        }

        private void BTNBack_Click(object sender, RoutedEventArgs e)
        {
            SPCheck.Visibility = Visibility.Collapsed;
            StartButton.Visibility = Visibility.Visible;
        }
    }
}
