﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Remoting.Metadata.W3cXsd2001;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace LoLHelper
{
    /// <summary>
    /// Логика взаимодействия для LoginUserWindow.xaml
    /// </summary>
    public partial class LoginUserWindow : Window
    {
        int ID;
        User user = new User();
        public LoginUserWindow(int id)
        {
            InitializeComponent();
            try 
            { 
            ID = id;
            user = DataBase.entity.User.FirstOrDefault(x => x.id == id);
            TBLogin.Text = user.Login;
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void BTNRetry_Click(object sender, RoutedEventArgs e)
        {
            try 
            { 
            int p = PBRetryPassword.Password.GetHashCode();
            User userNow = DataBase.entity.User.FirstOrDefault(x => x.Password == p);
            ID = userNow.id;
            if (userNow != null)
            {
                MessageBox.Show("Благодарим за доверие! Теперь вы можете изменить пароль");
                SPRetry.Visibility = Visibility.Collapsed;
                SPRed.Visibility = Visibility.Visible;
            }
            else
            {
                MessageBox.Show("Пароль введён неверно!");
            }
        }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
}

        private void BTNRedact_Click(object sender, RoutedEventArgs e)
        {
            bool flag = true;
            Regex check1 = new Regex("^(?=.*[0-9]){2,}");
            Regex check2 = new Regex("(?=.*[a-z]){3,}");
            Regex check3 = new Regex("(?=.*[A-Z])");
            Regex check4 = new Regex("(?=.*[!@#$%^&*()=+_])");
            Regex check5 = new Regex("[0-9a-zA-Z!@#$%^&*()=+_]{8,}");
            while (flag)
            {
                if (TBLogin != null && PBPassword.Password != null)
                {
                    if (check1.IsMatch(PBPassword.Password) && check2.IsMatch(PBPassword.Password) && check3.IsMatch(PBPassword.Password) && check4.IsMatch(PBPassword.Password) && check5.IsMatch(PBPassword.Password))
                    {
                        user.Login = TBLogin.Text;
                        user.Password = PBPassword.Password.GetHashCode();
                        user = DataBase.entity.User.FirstOrDefault(x => x.Login == TBLogin.Text);
                        if (user != null && user.id != ID)
                        {
                            MessageBox.Show("Этот логин уже занят");
                            flag = false;
                        }
                        else
                        {
                            DataBase.entity.SaveChanges();
                            MessageBox.Show("Редактирование данных успешно завершено");
                            this.Close();
                            flag = false;
                        }
                    }
                    else if (check1.IsMatch(PBPassword.Password) == false)
                    {
                        MessageBox.Show("В пароле должно быть не менее 2 цифр!");
                        flag = false;
                    }
                    else if (check2.IsMatch(PBPassword.Password) == false)
                    {
                        MessageBox.Show("В пароле должно быть не менее 3 строчных латинских букв!");
                        flag = false;
                    }
                    else if (check3.IsMatch(PBPassword.Password) == false)
                    {
                        MessageBox.Show("В пароле должно быть не менее 1 заглавной латинской буквы!");
                        flag = false;
                    }
                    else if (check4.IsMatch(PBPassword.Password) == false)
                    {
                        MessageBox.Show("В пароле должно быть не менее 1 специального символа!");
                        flag = false;
                    }
                    else if (check5.IsMatch(PBPassword.Password) == false)
                    {
                        MessageBox.Show("Длина пароля должна составлять не менее 8 символов!");
                        flag = false;
                    }
                }
                else
                {
                    MessageBox.Show("Не все данные введены");
                    flag = false;
                }
            }
        }
    }
}
