﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace LoLHelper
{
    /// <summary>
    /// Логика взаимодействия для PersonalUserDataWindow.xaml
    /// </summary>
    public partial class PersonalUserDataWindow : Window
    {
        User user = new User();
        public PersonalUserDataWindow(int id)
        {
            try {
            InitializeComponent();
            CBGender.ItemsSource = DataBase.entity.UserGender.ToList();
            CBGender.SelectedValuePath = "id";
            CBGender.DisplayMemberPath = "Gender";
            user = DataBase.entity.User.FirstOrDefault(x=>x.id == id);
            Surname.Text = user.Surname;
            Name.Text = user.Name;
            Softname.Text = user.Softname;
            DP.Text = user.Birthday.ToString();
            CBGender.SelectedIndex = user.Gender-1;
        }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
}

        private void BTNRedact_Click(object sender, RoutedEventArgs e)
        {
            try 
            { 
            user.Surname = Surname.Text;
            user.Name = Name.Text;
            user.Softname = Softname.Text;
            user.Gender = ((UserGender)CBGender.SelectedItem).id;
            user.Birthday = (DateTime)DP.SelectedDate;
            DataBase.entity.SaveChanges();
            MessageBox.Show("Редактирование данных успешно завершено!");
            this.Close();
        }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
}
    }
}
