﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace LoLHelper
{
    /// <summary>
    /// Логика взаимодействия для UserPage.xaml
    /// </summary>
    public partial class UserPage : Page
    {
        string Path;
        User user = new User();
        void showImage(byte[] array, System.Windows.Controls.Image img)
        {
            BitmapImage BI = new BitmapImage();
            BI.BeginInit();
            BI.StreamSource = new MemoryStream(array); 
            BI.EndInit(); 
            img.Source = BI;
            img.Stretch = Stretch.Uniform;
        }
        public UserPage(int id)
        {
            InitializeComponent();
            user = DataBase.entity.User.FirstOrDefault(x => x.id== id);
                TBFIO.Text = user.Surname + " " + user.Name + " " + user.Softname;
                TBBirthday.Text = user.Birthday.ToString("Дата рождения: dd.MM.yyyy");
            UserPhotos up = DataBase.entity.UserPhotos.FirstOrDefault(x => x.ID == user.Avatar);
            if (up != null)
            {
                byte[] Bar = up.Photo;
                showImage(Bar, IMGUser);
            }
        }

        private void BTNPhoto_Click(object sender, RoutedEventArgs e)
        {
            try
            {

            
            UserPhotos photos = new UserPhotos();
            OpenFileDialog OFD  = new OpenFileDialog();
            OFD.Filter = "Изображения | *.jpg; *.png; *.jpeg; *.jfif";
            OFD.ShowDialog();
            photos.UserID = user.id;
            Path = OFD.FileName;
            photos.Photo = File.ReadAllBytes(Path);
            DataBase.entity.UserPhotos.Add(photos);
            DataBase.entity.SaveChanges();
            user.Avatar = photos.ID;
            DataBase.entity.SaveChanges();
            MessageBox.Show("Изображение добавлено!");
            ClassFrame.MFrame.Navigate(new UserPage(user.id));
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void BTNRedactPerson_Click(object sender, RoutedEventArgs e)
        {
            PersonalUserDataWindow win = new PersonalUserDataWindow(user.id);
            win.ShowDialog();
            ClassFrame.MFrame.Navigate(new UserPage(user.id));
        }

        private void BTNRedactLogin_Click(object sender, RoutedEventArgs e)
        {
            LoginUserWindow win = new LoginUserWindow(user.id);
            win.ShowDialog();
            ClassFrame.MFrame.Navigate(new UserPage(user.id));
        }

        private void BTNBack_Click(object sender, RoutedEventArgs e)
        {
            if (user.Role == 2)
            {
ClassFrame.MFrame.Navigate(new MainPage());
            }
            else
            {
                ClassFrame.MFrame.Navigate(new AdminPage());
            }
            
        }

        private void BTNGallery_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog OFD = new OpenFileDialog();
            OFD.Filter = "Image Files(*.BMP; *.JPG; *.GIF)| *.BMP; *.JPG; *.GIF";
            OFD.Multiselect = true;
            if (OFD.ShowDialog() == true)
            {
                foreach (string file in OFD.FileNames)
                {
                    UserPhotos up = new UserPhotos();
                    up.UserID = user.id;
                    up.Photo = File.ReadAllBytes(file);
                    DataBase.entity.UserPhotos.Add(up);
                }
            }
            DataBase.entity.SaveChanges();
            MessageBox.Show("Фотографии успешно добавлены!");
        }

        List<UserPhotos> _photos = new List<UserPhotos>();
        int n = 0;
        int h = 0;
        private void BTNTuda_Click(object sender, RoutedEventArgs e)
        {
            n++;
            byte[] Bar = _photos[n].Photo;
            showImage(Bar, imgGallery);
            if(_photos.Count == n + 1)
            {
                n = 0;
            }
        }

        private void BTNSuda_Click(object sender, RoutedEventArgs e)
        {
            byte[] Bar = _photos[n].Photo;
            showImage(Bar, imgGallery);
            if (n == 0)
            {
                for(int i = 0; i < _photos.Count+1; i++)
            {
                h = i;
            }
                n = h;
            }
            n--;
        }

        private void BTNChoose_Click(object sender, RoutedEventArgs e)
        {
            byte[] Bar = _photos[n].Photo;
            showImage(Bar, imgGallery);
            user.Avatar = _photos[n].ID;
            DataBase.entity.SaveChanges();
            MessageBox.Show("Фото выбрано");
            SPGallery.Visibility = Visibility.Collapsed;
            ClassFrame.MFrame.Navigate(new UserPage(user.id));
            n = 0;
        }

        private void BTNChooseGallery_Click(object sender, RoutedEventArgs e)
        {
            SPGallery.Visibility = Visibility.Visible;
            _photos = DataBase.entity.UserPhotos.Where(x=>x.UserID == user.id).ToList();
            if (_photos != null)
            {
                byte[] Bar = _photos[n].Photo;
                showImage(Bar, imgGallery);
            }
            if(_photos.Count == 1)
            {
                BTNTuda.IsEnabled = false; 
                BTNSuda.IsEnabled = false;
            }
        }
    }
}
